# Copyright (c) 2001, Gemini Data Loggers (UK) Ltd

import asyncore

socket_map = {}

class asyncore_in_server_thread:
    """Mixin class for asyncore.dispatchers
    
    Get those dispatchers to register with a different socket map,
    so that they are handled by the select loop in
    the ReplicatedFile server thread.
    """

    def add_channel(self, map=None):
        if map is None:
            map = socket_map
        return asyncore.dispatcher.add_channel(self,map)

    def del_channel(self, map=None):
        if map is None:
            map = socket_map
        return asyncore.dispatcher.del_channel(self,map)


   