# simplified version of zdaemon, distributed as part of Zope under ZPL

import os, sys, time, signal, posix
import fcntl, FCNTL

pyth = sys.executable

def run(argv, pidfile=''):
    if os.environ.has_key('ZDAEMON_MANAGED'):
        # We're the child at this point.  Don't ask. :/
        return
    
    os.environ['ZDAEMON_MANAGED']='TRUE'
    
    if not os.environ.has_key('Z_DEBUG_MODE'):
        # Detach from terminal
        pid = os.fork()
        if pid:
            sys.exit(0)
        posix.close(0); sys.stdin  = open('/dev/null')
        posix.close(1); sys.stdout = open('/dev/null','w')
        posix.close(2); sys.stderr = open('/dev/null','w')
        posix.setsid()

    if pidfile:
        try:
            pf = open(pidfile, 'r+')
        except:
            pf = open(pidfile, 'w+')
        fcntl.flock(pf.fileno(),FCNTL.LOCK_EX|FCNTL.LOCK_NB)
    else:
	pf = None

    try:
        try:
            while 1:
                pid = os.fork()
                if pid:
                    # Parent
                    p,s = os.waitpid(pid, 0)
                    if s in [0,15]:
                        # happy exit, or SIG_TERM
                        sys.exit(0)
                    else:
                        pass
                        # around the while loop
                else:
                    # Child
                    if pf:
                        pf.seek(0)
                        pf.write(("%s" % os.getpid()))
                        pf.flush()
                        pf.truncate()
                    os.execv(pyth, (pyth,)+tuple(argv))
        except KeyboardInterrupt:
            sys.exit(0)
    finally:
        if pidfile:
            os.unlink(pidfile)
            pf.close()



